<%
'SUBROUTINES DEFINED:
'"""""""""""""""""""
'SetupSessionVariables(AuthUser)		Sets up the session variables
'GetSessionStatusStr()					Returns the error string associated with the session error code
'SetError(Message)						Sets the text of the main error message
'SetReason(Message)						Sets the text of the reason paragraph
'AddFix(Message)						Adds an item to the bulleted list of suggestions
'Check_Browser_Capabilities()			Sets error if the Client browser lacks Tables and JavaScript support
'Invalid_Password()						Sets an error due to an invalid password
'IsConfID()								Sets error if the Conference ID is not set (inConfID)
'ValidateMeetingID()					Sets error if the DCS Meeting ID is not valid (inMeetingID)
'Verify_ConfLocator()					Verifies ConfLocator points to the Conference Locator
'DisplayErrorPage()						Setup the error page when we have an error
'
'FUNCTIONS DEFINED:
'"""""""""""""""""
'CheckSetError(Source, Description) Checks for error values in Result/Err and adds error messages if appropriate
'
' ================================ CONSTANTS =================================================
'ERROR CONSTANTS:
'C++ returns HRESULTS as 4-byte signed ints, so the bit pattern
'0x81000203 comes out as a negative number.
'VBScript also uses 4-byte signed ints, so assigning the bit patterns
'as below makes for better readability while still giving the 
'same negative numbers.
'If VBScript ever changes to use ints larger than 4 bytes, the
'bit patterns below will be interpreted as positive numbers and
'will have to be changed to explicitly reference the negative
'number returned by C++.
CONST E_CMS_EVENTMANAGER_NOT_INITIALIZED                = &H8004100A
CONST E_CMS_CONFERENCE_NOT_SCHEDULED                    = &H8004100B
CONST E_CMS_CONFERENCE_NOT_STARTED                      = &H8004100C
CONST E_CMS_CONFERENCE_NOT_RUNNING                      = &H8004100D
CONST E_CMS_CONFERENCE_NOT_FOUND                        = &H8004100E
CONST E_CMS_INVALID_CONFERENCE_PASSWORD                 = &H8004100F
CONST E_CMS_ANONYMOUS_USER_DENIED_ACCESS                = &H80041010
CONST E_CMS_USER_DENIED_ACCESS                          = &H80041011
CONST E_CMS_CTP_JOIN_REQUEST_FAILED                     = &H80041012
CONST E_CMS_PROVIDER_NOT_INITIALIZED                    = &H80041013
CONST E_CMS_PROVIDER_NOT_FOUND                          = &H80041014
CONST E_CMS_E_CONFERENCE_NOT_EXIST                      = &H80041015
CONST E_CMS_RECURRING_CONFERENCE_NOT_FOUND              = &H80041016
CONST E_CMS_NOT_HOST_SERVER                             = &H80041017
CONST E_CMS_RECURRING_INSTANCE_NOT_WITHIN_TIME_BOUND    = &H80041018
CONST E_CMS_AMBIGUOUS_RECURRING_JOIN                    = &H80041019
CONST E_CMS_TIME_EXTENSIONS_NOT_ALLOWED                 = &H8004101B
CONST E_CMS_RESOURCE_EXTENSIONS_NOT_ALLOWED             = &H8004101C
CONST E_CMS_SERVER_NOT_INITIALIZED                      = &H80041037
CONST E_CMS_PROFILE_STORE_NOT_INITIALIZED               = &H80041038
CONST E_CMS_SHUTTING_DOWN                               = &H4101E

CONST E_DCS_NO_MCUS_AVAILABLE                           = &H8004F001
CONST E_DCS_CONFERENCE_NOT_RUNNING                      = &H8004F002
CONST E_DCS_CONFERENCE_ALREADY_ENDED                    = &H8004F003
CONST E_DCS_ACCESS_DENIED_CAPACITY_LIMIT                = &H8004F004
CONST E_DCS_NO_PROXY_MCUS_AVAILABLE                     = &H8004F005
CONST E_DCS_NO_INTERNET_MCUS_AVAILABLE                  = &H8004F006
CONST E_DCS_NOT_RUNNING                                 = &H8004F007
CONST E_DCS_NOT_INIT                                    = &H8004F008

CONST E_NETMEETING_ERRORS_MASK                          = &H80040300
CONST E_NETMEETING_INVITE_FAILURE                       = &H8004036A
CONST E_NETMEETING_INVITE_TIMEOUT                       = &H80040372

CONST E_PKCS7_NO_CERT_STORE                             = &H80043000
CONST E_SESSION_UNAVAILABLE                             = &H80043001
CONST E_NO_DISPLAY_STATE                                = &H80043002
CONST E_UNSUPPORTED_TABLES_BROWSER                      = &H80043003
CONST E_UNSUPPORTED_JAVASCRIPT_BROWSER                  = &H80043004

CONST E_ACCESS_DENIED                                   = 70 '&H80070005 comes across as error 70 if returned
CONST E_ACCESS_DENIED_HRESULT                           = &H80070005 'if passed back as a result
CONST E_SERVER_CREATE_OBJECT                            = &H800401F3 'Server.CreateObject() error
CONST NM_E_NOT_ACTIVE                                   = &H81000203 'NetMeeting was closed since last use
CONST E_NO_GLOBAL_CONF_CALENDAR                         = &H80010105
CONST E_DSGETSITENAME_NO_SITE                           = &H8007077F
CONST E_MANUAL_JOIN_INSTRUCTIONS                        = &H80040100
CONST E_CMS_RESTARTED                                   = &H1CE

CONST E_MCU_HANG                                        = &H800706BA
CONST E_MCU_NO_SERVER_CERTIFICATE                       = &H80070546

'DISPLAY STATE CONTANTS:
'These define the various display states that can be used
'The quotes are required because the state is passed as a string
'The DCS programmatically uses {0,7,8} so those cannot easily be changed
CONST DISPLAY_JOIN                      = "0"
CONST DISPLAY_JOIN_PASSWORD             = "6"
CONST DISPLAY_PREJOIN                   = "7"
CONST DISPLAY_POSTJOIN                  = "8"
CONST DISPLAY_NO_MADCAP_SERVERS         = "9"
CONST DISPLAY_TOO_MANY_USERS            = "10"
CONST DISPLAY_ALL_MADCAP_SERVERS_FAILED = "11"
CONST DISPLAY_NO_MADCAP_SERVERS_MATCH_SCOPE = "12"
CONST DISPLAY_NO_MADCAP_SCOPES_FOUND    = "13"
CONST DISPLAY_NO_SCOPES_IN_RESOURCE     = "14"
CONST DISPLAY_MAX_JOIN_TYPES            = "14"
CONST DISPLAY_MULTICAST_CLIENT          = "15"
CONST DISPLAY_H323_CLIENT               = "16"
CONST DISPLAY_OLDER_H323_CLIENT         = "51"
CONST DISPLAY_NO_AUDIOVIDEO_CLIENT      = "52"
CONST DISPLAY_NO_AUDIOVIDEO_ACTIVEX     = "53"

CONST DISPLAY_WELCOME                   = "11"
CONST DISPLAY_RECURRING                 = "14"
CONST DISPLAY_AGENDA                    = "17"
CONST DISPLAY_MODIFY                    = "18"
CONST DISPLAY_MAX_NO_JOIN_TYPES         = "19"

CONST DISPLAY_MIN_ERR_TYPES             = "20"
CONST DISPLAY_ERR_CONFID                = "22"
CONST DISPLAY_ERR_CTP_STARTUP           = "23"
CONST DISPLAY_ERR_VALUE                 = "38"
CONST DISPLAY_MAX_ERR_TYPES             = "39"

'SESSION VARIABLE CONSTANTS
CONST SESSION_CONFPROFILE            = "ConfProfile"
CONST SESSION_CONFLOCATOR            = "ConfLocator"
CONST SESSION_CMSZONE                = "CMSZone"
CONST SESSION_CMSCONFIG              = "CMSConfig"
CONST SESSION_MEETINGID              = "MeetingID"
CONST SESSION_RESULT                 = "Result"
CONST SESSION_ERRNUMBER              = "ErrNumber"
CONST SESSION_ERRSOURCE              = "ErrSource"
CONST SESSION_ERRDESCRIPTION         = "ErrDescription"
CONST SESSION_STATUS                 = "Status"
CONST SESSION_ATTENDEE               = "Attendee"
CONST SESSION_PASSWORD				 = "Password"

CONST L_Page_HTMLTitle       = "Conferenze di Microsoft Exchange"
CONST L_ErrorPage_HTMLTitle  = "Conferenze di Microsoft Exchange - Errore"
CONST L_TryTheFollowing_Text = "Provare a eseguire le operazioni seguenti:"

'Session debugging/status information strings (must stay the same as global.asa)
CONST L_OK_Text                 = "OK"
CONST L_GetConfLocator_Text     = "Impossibile ottenere il selettore luogo conferenza dalla zona di gestione conferenze."
CONST L_GetZone_Text            = "Impossibile individuare la zona dall'oggetto di configurazione della gestione conferenze."
CONST L_CreateObject_Text       = "Impossibile inizializzare l'oggetto di configurazione della gestione conferenze."
CONST L_Unknown_Text            = "Sconosciuto"
CONST L_Uninitialized_Text      = "Non inizializzato"

'Common strings
CONST L_MCUProxyInvite_ErrorMessage     = "Se si sta tentando di partecipare alla conferenza tramite un server proxy, è possibile che il Servizio conferenza dati non sia in grado di connettersi al programma client. Per effettuare la connessione manuale al client di conferenza dati, utilizzare le seguenti informazioni:"
CONST L_ManualJoinServer_ErrorMessage   = "Server delle conferenze dati: "
CONST L_ManualJoinID_ErrorMessage       = "ID della conferenza: "
CONST L_ManualJoinPassword_ErrorMessage = "Password della conferenza: "
CONST L_NetMeetingInviteTitle_ErrorMessage  = "Errore nell'invito alla conferenza dati."
CONST L_NetMeetingInviteReason_ErrorMessage = "Il Servizio conferenza dati non è in grado di invitare alla conferenza il programma client di conferenza dati T.120 in uso (ad esempio, Microsoft NetMeeting)."
CONST L_NetMeetingInviteFix1_ErrorMessage   = "Assicurarsi che il programma client di conferenza sia stato avviato, quindi provare nuovamente a partecipare alla conferenza."
CONST L_LinkToConferenceListsFix_ErrorMessage  = "Selezionare una conferenza corrente "
CONST L_LinkToConferenceListsFix2_ErrorMessage = "dall'elenco di riunioni disponibili."

CONST PR_SUBJECT             = "subject"   'Defines the subject property code for user properties
CONST PR_BODY                = "268435487" 'Defines the body text property code for user properties
CONST PR_BODY_HTML           = "269680670" 'Defines the body text (in HTML) property code for user properties
CONST MAPI_RESOURCE          = "MAPI"      'Defines the resource used when getting user properties

CONST CONF_ID_CODED_LENGTH   = 255 'Length of the Base-64 encoded conference ID
CONST CONF_ID_DECODED_LENGTH = 22 'Conference ID must be 22 digits

' ================================ VARIABLES =================================================
'ERROR VARIABLES:
DIM ErrorMsg        'Holds the main error message (displayed at the top of the error page)
DIM Reason          'Holds the paragraph description of the error (displayed below the main message)
DIM Fixes()         'Holds the suggested remedies (displayed in the bulleted list below the paragraph)
DIM HiddenError     'Holds the system-level error message (displayed in small print at the bottom)
DIM ErrorCount      'Counts the errors encountered (0 or 1)
DIM Result          'Global variable used for function return values
DIM SessionErr(5)   'Holds the error messages that are defined in the session variables code to allow localization

' =============================== INITIALIZATION ==============================================
ErrorMsg        = ""
HiddenError     = ""
Reason          = ""
ErrorCount      = 0
Result          = 0
SessionErr(0)   = L_OK_Text
SessionErr(1)   = L_GetConfLocator_Text
SessionErr(2)   = L_GetZone_Text
SessionErr(3)   = L_CreateObject_Text
SessionErr(4)   = L_Unknown_Text
SessionErr(5)   = L_Uninitialized_Text
REDIM Fixes(0)                          'Puts the array Fixes in a known state

' ================================ FUNCTIONS =================================================
'== SUB: Sets up the session variables (GetSessionStatusStr() is used for SESSION_STATUS strings)
SUB SetupSessionVariables(AuthUser)
    ON ERROR RESUME NEXT

    DIM CMSConfiguration
    DIM CMSZone
    DIM ConfLocator
    
    Session(SESSION_RESULT)          = 0
    Session(SESSION_ERRNUMBER)       = 0
    Session(SESSION_ERRSOURCE)       = 0
    Session(SESSION_ERRDESCRIPTION)  = 0
    Session(SESSION_STATUS)          = 5 'L_Uninitialized_Text
    
    'Create the CMS Configuration object (dllhost will create this from xcmsadm)
    SET CMSConfiguration = Server.CreateObject("XCMSCOM.CMSConfiguration")
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 3 'L_CreateObject_Text
        EXIT SUB
    END IF
    
    SET Session(SESSION_CMSCONFIG) = CMSConfiguration 'Save the singleton CMSConfig for up to 20 mins
    
    'Create the CMS Zone object (dllhost will create this from xcmsadm)
    CALL CMSConfiguration.GetZone("", CMSZone)
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_RESULT)         = Err.Number
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 2 'L_GetZone_Text
        EXIT SUB
    END IF
    
    SET Session(SESSION_CMSZONE) = CMSZone 'Save the CMS Zone object for use later
    
    'Create the Conference Locator object (dllhost will create this from the xconfmgr service)
    CALL CMSZone.GetConferenceLocator(ConfLocator)
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_RESULT)         = Err.Number
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 1 'L_GetConfLocator_Text
        EXIT SUB
    END IF

	Session(SESSION_ATTENDEE)		 = AuthUser
	    
    SET Session(SESSION_CONFLOCATOR) = ConfLocator 'Save the Conference Locator for use later
    Session(SESSION_STATUS)          = 0 'L_OK_Text
END SUB

'== SUB: Creates the session status string that we use on the bottom of the error pages
FUNCTION GetSessionStatusStr(errVal)
    IF (errVal >= 0 AND errVal <= 5) THEN
        GetSessionStatusStr = SessionErr(errVal)
    ELSE
        GetSessionStatusStr = errVal
    END IF
END FUNCTION

'== SUB: Sets the text of the main error message
SUB SetError(Message, Value, Source, Description)
    IF (0 = ErrorCount) THEN
        ErrorCount  = ErrorCount + 1
        ErrorMsg    = ErrorMsg & Message
        HiddenError = HiddenError & Source & " Error #" & Hex(Value) & ": " & Description & vbNewLine
    END IF
END SUB

'== SUB: Sets the text of the reason paragraph
SUB SetReason(Message)
    Reason = Message
END SUB

'== SUB: Adds an item to the bulleted list of suggestions
SUB AddFix(Message)
    DIM NewSize
    
    NewSize = UBound(Fixes) + 1
    REDIM PRESERVE Fixes(NewSize)
    
    Fixes(NewSize) = Message
END SUB

'== FUNCTION: Checks for error values in Result/Err and adds error messages if appropriate
FUNCTION CheckSetError(ResultSource, ResultDescription)
    DIM Value, Source, Description
    
    IF (0 <> Err.Number) THEN
        Value       = Err.Number
        Source      = Err.Source & " / [" & ResultSource & "]"
        Description = Err.Description & " / [" & ResultDescription & "]"
        Err.Clear()
    ELSEIF (0 <> Result) THEN
        IF (IsNumeric(Result)) THEN
            Value = CDbl(Result)
        ELSE
            Value = Result
        END IF
        Source      = ResultSource
        Description = ResultDescription
        Result      = 0
    ELSE
        CheckSetError = FALSE
        EXIT FUNCTION
    END IF

    'Bitwise-AND to detect all NetMeeting errors
    IF (E_NETMEETING_ERRORS_MASK = (E_NETMEETING_ERRORS_MASK AND Value)) THEN

        IF (E_NETMEETING_INVITE_FAILURE = Value) THEN
            
            CALL SetError(L_NetMeetingInviteTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteReason_ErrorMessage)
            CALL AddFix(L_NetMeetingInviteFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        ELSEIF (E_NETMEETING_INVITE_TIMEOUT = Value) THEN
            CONST L_NetMeetingInviteTimeoutTitle_ErrorMessage  = "Timeout dell'invito alla conferenza dati."
            CONST L_NetMeetingInviteTimeoutReason_ErrorMessage = "L'invito inviato dal server delle conferenze dati è scaduto mentre il server tentava di invitare alla conferenza programma client per conferenze in uso (ad esempio Microsoft NetMeeting)."
            CONST L_NetMeetingInviteTimeoutFix1_ErrorMessage   = "Accedere nuovamente alla conferenza e accettare l'invito del server. Potrebbe essere necessario portare l'invito in primo piano, poiché potrebbe essere nascosto dietro la finestra attiva."
            
            CALL SetError(L_NetMeetingInviteTimeoutTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteTimeoutReason_ErrorMessage)
            CALL AddFix(L_NetMeetingInviteTimeoutFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        ELSE
            CONST L_NetMeetingMaskTitle_ErrorMessage  = "Conflitto in NetMeeting"
            CONST L_NetMeetingMaskReason_ErrorMessage = "NetMeeting sta assumendo il controllo di alcune risorse del computer in uso o non sta funzionando correttamente."
            CONST L_NetMeetingMaskFix1_ErrorMessage   = "Chiudere eventuali altri programmi video, audio o di rete che possono entrare in conflitto con NetMeeting."
            
            CALL SetError(L_NetMeetingMaskTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingMaskReason_ErrorMessage)
            CALL AddFix(L_NetMeetingMaskFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        END IF

        EXIT FUNCTION
    END IF

    SELECT CASE Value
        CASE E_CMS_EVENTMANAGER_NOT_INITIALIZED,E_CMS_SERVER_NOT_INITIALIZED
            CONST L_EventManagerNotInitializedTitle_ErrorMessage  = "Server non inizializzato"
            CONST L_EventManagerNotInitializedReason_ErrorMessage = "Avvio del Servizio conferenze di Exchange in corso. Il processo non è stato ancora completato."
            CONST L_EventManagerNotInitializedFix1_ErrorMessage   = "Attendere alcuni minuti e riprovare."
            
            CALL SetError(L_EventManagerNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_EventManagerNotInitializedReason_ErrorMessage)
            CALL AddFix(L_EventManagerNotInitializedFix1_ErrorMessage)
        
        CASE E_CMS_PROFILE_STORE_NOT_INITIALIZED
            CONST L_ServerOrProfileStoreNotInitializedTitle_ErrorMessage    = "Archivio server non inizializzato"
            CONST L_ServerOrProfileStoreNotInitializedReason_ErrorMessage   = "Server di conferenze di Exchange non inizializzato."
            CONST L_ProfileStoreNotInitializedFix1_ErrorMessage             = "Contattare l'amministratore del sistema. L'archivio delle cassette postali per il calendario delle conferenze potrebbe essere non disponibile."
                        
            CALL SetError(L_ServerOrProfileStoreNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ServerOrProfileStoreNotInitializedReason_ErrorMessage)
            CALL AddFix(L_ProfileStoreNotInitializedFix1_ErrorMessage)

        CASE E_CMS_CONFERENCE_NOT_RUNNING
            CONST L_ConferenceNotRunningCMSTitle_ErrorMessage  = "Conferenza non in esecuzione"
            CONST L_ConferenceNotRunningCMSReason_ErrorMessage = "La conferenza a cui si tenta di partecipare non è pronta oppure un provider della tecnologia di conferenza non ne consente l'inizio."
            CONST L_ConferenceNotRunningCMSFix1_ErrorMessage   = "Attendere alcuni minuti e riprovare."
            
            CALL SetError(L_ConferenceNotRunningCMSTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotRunningCMSReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotRunningCMSFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_CONFERENCE_NOT_SCHEDULED
            CONST L_ConferenceNotScheduledTitle_ErrorMessage  = "Conferenza non programmata"
            CONST L_ConferenceNotScheduledReason_ErrorMessage = "Questa conferenza, determinata dall'ID riunione nell'URL, non è stata pianificata dal Servizio conferenze di Exchange."
            CONST L_ConferenceNotScheduledFix1_ErrorMessage   = "È possibile che la conferenza sia stata eliminata oppure che l'ID della conferenza sia danneggiato."
            CONST L_ConferenceNotScheduledFix2_ErrorMessage   = "Contattare l'organizzatore della riunione oppure l'amministratore del sistema."
            
            CALL SetError(L_ConferenceNotScheduledTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotScheduledReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotScheduledFix1_ErrorMessage)
            CALL AddFix(L_ConferenceNotScheduledFix2_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
        
        CASE E_CMS_CONFERENCE_NOT_STARTED
            CONST L_ConferenceNotStartedTitle_ErrorMessage  = "Conferenza non avviata"
            CONST L_ConferenceNotStartedReason_ErrorMessage = "La procedura di avvio della conferenza è iniziata ma non è stata ancora completata."
            CONST L_ConferenceNotStartedFix1_ErrorMessage   = "Attendere alcuni minuti e riprovare."
            
            CALL SetError(L_ConferenceNotStartedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotStartedReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotStartedFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_CONFERENCE_NOT_FOUND,E_CMS_RECURRING_INSTANCE_NOT_WITHIN_TIME_BOUND,E_CMS_AMBIGUOUS_RECURRING_JOIN,E_CMS_E_CONFERENCE_NOT_EXIST,1 'S_FALSE
            CONST L_ConferenceNotFoundTitle_ErrorMessage  = "Conferenza non trovata"
            CONST L_ConferenceNotFoundReason_ErrorMessage = "Impossibile trovare la conferenza a cui si desidera partecipare."
            CONST L_ConferenceNotFoundFix1_ErrorMessage   = "Se la conferenza è stata pianificata di recente, attendere alcuni minuti e riprovare."
            CONST L_ConferenceNotFoundFix2_ErrorMessage   = "Contattare l'organizzatore della conferenza. È possibile che la conferenza sia stata annullata."
            CONST L_ConferenceNotFoundFix3_ErrorMessage   = "Assicurarsi che l'ID della riunione visualizzato nell'URL del browser in uso corrisponda a quello dell'ID riunione della conferenza."
            CONST L_ConferenceNotFoundFix4_ErrorMessage   = "Se la conferenza è ricorrente, è possibile che si siano verificati dei problemi nella risoluzione delle singole ricorrenze."
            
            CALL SetError(L_ConferenceNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotFoundReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix1_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix2_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix3_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix4_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_SHUTTING_DOWN
            CONST L_ConfServerShuttingDownTitle_ErrorMessage  = "Arresto del Servizio gestione conferenze in corso..."
            CONST L_ConfServerShuttingDownReason_ErrorMessage = "È in corso l'arresto del Servizio gestione conferenze."
            CONST L_ConfServerShuttingDownFix1_ErrorMessage   = "Attendere alcuni minuti per riavviare il servizio e riprendere la conferenza."
            CONST L_ConfServerShuttingDownFix2_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_ConfServerShuttingDownTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConfServerShuttingDownReason_ErrorMessage)
            CALL AddFix(L_ConfServerShuttingDownFix1_ErrorMessage)
            CALL AddFix(L_ConfServerShuttingDownFix2_ErrorMessage)

        CASE E_CMS_INVALID_CONFERENCE_PASSWORD
            CONST L_InvalidConferencePasswordTitle_ErrorMessage  = "Password conferenza non valida."
            CONST L_InvalidConferencePasswordReason_ErrorMessage = "La richiesta di partecipazione alla conferenza è stata rifiutata poiché la password specificata non è valida."
            CONST L_InvalidConferencePasswordFix1_ErrorMessage   = "Assicurarsi che la password di conferenza immessa sia corretta."

            CALL SetError(L_InvalidConferencePasswordTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_InvalidConferencePasswordReason_ErrorMessage)
            CALL AddFix(L_InvalidConferencePasswordFix1_ErrorMessage)
        
        CASE E_CMS_ANONYMOUS_USER_DENIED_ACCESS
            CONST L_AnonymousUserDeniedAccessTitle_ErrorMessage  = "Accesso anonimo negato"
            CONST L_AnonymousUserDeniedAccessReason_ErrorMessage = "La richiesta di partecipazione alla conferenza è stata rifiutata per l'impossibilità di identificare l'utente."
            CONST L_AnonymousUserDeniedAccessFix1_ErrorMessage   = "Assicurarsi che la conferenza a cui si sta tentando di partecipare non sia una conferenza privata a cui non si è stati invitati."
            CONST L_AnonymousUserDeniedAccessFix2_ErrorMessage   = "Assicurarsi di essere collegato alla rete col proprio identificativo, in modo da consentire l'identificazione."

            CALL SetError(L_AnonymousUserDeniedAccessTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_AnonymousUserDeniedAccessReason_ErrorMessage)
            CALL AddFix(L_AnonymousUserDeniedAccessFix1_ErrorMessage)
            CALL AddFix(L_AnonymousUserDeniedAccessFix2_ErrorMessage)
        
        CASE E_CMS_USER_DENIED_ACCESS
            CONST L_UserDeniedAccessTitle_ErrorMessage  = "Accesso negato"
            CONST L_UserDeniedAccessReason_ErrorMessage = "La richiesta di partecipazione alla conferenza è stata rifiutata per mancanza delle autorizzazioni necessarie. Autenticato come: "
            CONST L_UserDeniedAccessFix1_ErrorMessage   = "Assicurarsi che la conferenza a cui si sta tentando di partecipare non sia una conferenza privata a cui non si è stati invitati. Controllare l'invito originale e verificare che l'opzione Consenti partecipanti esterni sia selezionata, che nell'elenco A o CC sia riportato il proprio nome utente e che sia disponibile l'autenticazione al server con il nome utente indicato."
            CONST L_UserDeniedAccessFix2_ErrorMessage   = "Contattare l'amministratore del sistema. È possibile che le autorizzazioni della directory principale virtuale della conferenza possono non siano state impostate correttamente, oppure il Servizio gestione conferenze sta forzando l'autenticazione del client per le conferenze private, ovvero l'impostazione Autentica accesso alle pagine di riunioni private è selezionata."

            CALL SetError(L_UserDeniedAccessTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_UserDeniedAccessReason_ErrorMessage & Request.ServerVariables("AUTH_USER"))
            CALL AddFix(L_UserDeniedAccessFix1_ErrorMessage)
            CALL AddFix(L_UserDeniedAccessFix2_ErrorMessage)

        CASE E_CMS_CTP_JOIN_REQUEST_FAILED
            CONST L_CTPJoinRequestFailedTitle_ErrorMessage  = "Errore nella richiesta di partecipazione CTP"
            CONST L_CTPJoinRequestFailedReason_ErrorMessage = "La richiesta è stata rifiutata poiché il provider della tecnologia di conferenza non consente la partecipazione."
            CONST L_CTPJoinRequestFailedFix1_ErrorMessage   = "Contattare l'amministratore del sistema."

            CALL SetError(L_CTPJoinRequestFailedTitle_ErrorMessage, Value, Replace(Request.QueryString("PNAME"), "+"," "), Description)
            CALL SetReason(L_CTPJoinRequestFailedReason_ErrorMessage)
            CALL AddFix(L_CTPJoinRequestFailedFix1_ErrorMessage)
        
        CASE E_CMS_PROVIDER_NOT_INITIALIZED
            CONST L_ProviderNotInitializedTitle_ErrorMessage  = "Provider non inizializzato"
            CONST L_ProviderNotInitializedReason_ErrorMessage = "La richiesta è stata rifiutata poiché il provider della tecnologia di conferenza non ha completato l'inizializzazione."
            CONST L_ProviderNotInitializedFix1_ErrorMessage   = "Contattare l'amministratore del sistema."

            CALL SetError(L_ProviderNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ProviderNotInitializedReason_ErrorMessage)
            CALL AddFix(L_ProviderNotInitializedFix1_ErrorMessage)
        
        CASE E_CMS_PROVIDER_NOT_FOUND
            CONST L_ProviderNotFoundTitle_ErrorMessage  = "Provider non trovato"
            CONST L_ProviderNotFoundReason_ErrorMessage = "La richiesta è stata rifiutata poiché non è stato possibile contattare un provider della tecnologia di conferenza."
            CONST L_ProviderNotFoundFix1_ErrorMessage   = "Contattare l'amministratore del sistema."

            CALL SetError(L_ProviderNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ProviderNotFoundReason_ErrorMessage)
            CALL AddFix(L_ProviderNotFoundFix1_ErrorMessage)
        
        CASE E_CMS_RECURRING_CONFERENCE_NOT_FOUND
            CONST L_RecurringConferenceNotFoundTitle_ErrorMessage  = "Conferenza ricorrente non trovata"
            CONST L_RecurringConferenceNotFoundReason_ErrorMessage = "La richiesta è stata rifiutata poiché non è stata trovata la conferenza ricorrente a cui si desidera partecipare."
            CONST L_RecurringConferenceNotFoundFix1_ErrorMessage   = "Contattare l'amministratore del sistema."

            CALL SetError(L_RecurringConferenceNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_RecurringConferenceNotFoundReason_ErrorMessage)
            CALL AddFix(L_RecurringConferenceNotFoundFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
        
        CASE E_CMS_NOT_HOST_SERVER
            CONST L_NotHostServerTitle_ErrorMessage  = "URL host non valido"
            CONST L_NotHostServerReason_ErrorMessage = "La richiesta è stata rifiutata poiché il server utilizzato non è il server host."
            CONST L_NotHostServerFix1_ErrorMessage   = "Contattare l'amministratore del sistema."

            CALL SetError(L_NotHostServerTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NotHostServerReason_ErrorMessage)
            CALL AddFix(L_NotHostServerFix1_ErrorMessage)

        CASE E_DCS_NO_MCUS_AVAILABLE
            CONST L_NoAvailableMCUsTitle_ErrorMessage  = "Nessun server MCU T.120 disponibile"
            CONST L_NoAvailableMCUsReason_ErrorMessage = "Il Servizio conferenza dati non è disponibile o non è configurato per consentire una connessione a un server MCU T.120 dall'indirizzo in uso. Per partecipare a una conferenza, è necessario connettere il client per conferenze in uso (ad esempio, NetMeeting) a un server MCU T.120."
            CONST L_NoAvailableMCUsFix1_ErrorMessage   = "Se il problema persiste, contattare l'amministratore del sistema."
            
            CALL SetError(L_NoAvailableMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableMCUsFix1_ErrorMessage)

        CASE E_DCS_NO_PROXY_MCUS_AVAILABLE
            CONST L_NoAvailableProxyMCUsTitle_ErrorMessage  = "Nessun server proxy MCU T.120 disponibile"
            CONST L_NoAvailableProxyMCUsReason_ErrorMessage = "Il Servizio conferenza dati non è disponibile o non è configurato per consentire una connessione a un server proxy MCU T.120 dal sito Windows 2000 in uso. Per partecipare a una conferenza in un altro sito, è necessario disporre di una connessione a un server proxy MCU T.120."
            CONST L_NoAvailableProxyMCUsFix1_ErrorMessage   = "Se il problema persiste, contattare l'amministratore del sistema."
            
            CALL SetError(L_NoAvailableProxyMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableProxyMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableProxyMCUsFix1_ErrorMessage)

        CASE E_DCS_NO_INTERNET_MCUS_AVAILABLE
            CONST L_NoAvailableInternetMCUsTitle_ErrorMessage  = "Nessun server MCU T.120 Internet disponibile"
            CONST L_NoAvailableInternetMCUsReason_ErrorMessage = "Il Servizio conferenza dati non è disponibile o non è configurato per consentire una connessione a un server MCU T.120 Internet da un'altra organizzazione. Per partecipare a una conferenza gestita da un'altra organizzazione, è necessaria una connessione a un server MCU T.120 Internet."
            CONST L_NoAvailableInternetMCUsFix1_ErrorMessage   = "Se il problema persiste, contattare l'amministratore del sistema."
            
            CALL SetError(L_NoAvailableInternetMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableInternetMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableInternetMCUsFix1_ErrorMessage)

        CASE E_DCS_CONFERENCE_NOT_RUNNING
            CONST L_ConferenceNotRunningDCSTitle_ErrorMessage  = "Conferenza non in esecuzione"
            CONST L_ConferenceNotRunningDCSReason_ErrorMessage = "La conferenza non è in esecuzione sul server MCU T.120."
            CONST L_ConferenceNotRunningDCSFix1_ErrorMessage   = "Se il problema persiste, contattare l'amministratore del sistema."
            
            CALL SetError(L_ConferenceNotRunningDCSTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotRunningDCSReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotRunningDCSFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
            
        CASE E_DCS_CONFERENCE_ALREADY_ENDED
            CONST L_ConferenceAlreadyEndedTitle_ErrorMessage  = "Conferenza terminata"
            CONST L_ConferenceAlreadyEndedReason_ErrorMessage = "La conferenza dati a cui si è tentato di partecipare non è più in corso."
            CONST L_ConferenceAlreadyEndedFix1_ErrorMessage   = "Se il problema persiste, contattare l'amministratore del sistema."
            
            CALL SetError(L_ConferenceAlreadyEndedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceAlreadyEndedReason_ErrorMessage)
            CALL AddFix(L_ConferenceAlreadyEndedFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
            
        CASE E_DCS_ACCESS_DENIED_CAPACITY_LIMIT
            CONST L_CapacityLimitTitle_ErrorMessage  = "Limite capacità della conferenza dati"
            CONST L_CapacityLimitReason_ErrorMessage = "La conferenza dati ha raggiunto il limite di capacità e attualmente non può accettare nuovi utenti."
            CONST L_CapacityLimitFix1_ErrorMessage   = "Attendere alcuni minuti, quindi provare nuovamente a partecipare alla conferenza. È possibile che nel frattempo altri utenti abbiano abbandonato la conferenza."
            CONST L_CapacityLimitFix2_ErrorMessage   = "Contattare l'organizzatore della riunione."
            
            CALL SetError(L_CapacityLimitTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_CapacityLimitReason_ErrorMessage)
            CALL AddFix(L_CapacityLimitFix1_ErrorMessage)
            CALL AddFix(L_CapacityLimitFix2_ErrorMessage)

        CASE E_DCS_NOT_RUNNING
            CONST L_DCSNotRunningTitle_ErrorMessage  = "Servizio conferenza dati non in esecuzione"
            CONST L_DCSNotRunningReason_ErrorMessage = "Il Servizio conferenza dati non è al momento in esecuzione."
            CONST L_DCSNotRunningFix1_ErrorMessage   = "Attendere alcuni minuti, quindi provare nuovamente a partecipare alla conferenza. Potrebbe essere in corso il riavvio del servizio."
            CONST L_DCSNotRunningFix2_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_DCSNotRunningTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DCSNotRunningReason_ErrorMessage)
            CALL AddFix(L_DCSNotRunningFix1_ErrorMessage)
            CALL AddFix(L_DCSNotRunningFix2_ErrorMessage)

        CASE E_DCS_NOT_INIT
            CONST L_DCSNotInitTitle_ErrorMessage  = "Servizio conferenza dati non inizializzato"
            CONST L_DCSNotInitReason_ErrorMessage = "Inizializzazione del Servizio conferenza dati non completata."
            CONST L_DCSNotInitFix1_ErrorMessage   = "Attendere alcuni minuti, quindi provare nuovamente a partecipare alla conferenza."
            CONST L_DCSNotInitFix2_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_DCSNotInitTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DCSNotInitReason_ErrorMessage)
            CALL AddFix(L_DCSNotInitFix1_ErrorMessage)
            CALL AddFix(L_DCSNotInitFix2_ErrorMessage)

        CASE E_PKCS7_NO_CERT_STORE
            CONST L_NoCertStoreTitle_ErrorMessage    = "Errore durante l'apertura dell'Archivio certificati"
            CONST L_NoCertStoreReason_ErrorMessage   = "Errore durante l'apertura dell'Archivio certificati sul server di gestione conferenze a cui si stava tentando di accedere."
            CONST L_NoCertStoreFix1_ErrorMessage     = "Contattare l'amministratore del sistema."

            CALL SetError(L_NoCertStoreTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoCertStoreReason_ErrorMessage)
            CALL AddFix(L_NoCertStoreFix1_ErrorMessage)
        
        CASE E_MCU_NO_SERVER_CERTIFICATE
            CONST L_NoServerCertificateTitle_ErrorMessage    = "Nessun certificato del server delle conferenze dati."
            CONST L_NoServerCertificateReason_ErrorMessage   = "Il server delle conferenze dati di Exchange non è correntemente in grado di fornire conferenze private."
            CONST L_NoServerCertificateFix1_ErrorMessage     = "Contattare l'amministratore del sistema per assicurarsi che nel server delle conferenze dati sia installato un certificato computer."

            CALL SetError(L_NoServerCertificateTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoServerCertificateReason_ErrorMessage)
            CALL AddFix(L_NoServerCertificateFix1_ErrorMessage)

        CASE E_MANUAL_JOIN_INSTRUCTIONS            
            CONST L_ManualJoinInstructionsTitle_ErrorMessage  = "Istruzioni di partecipazione"
            CALL SetError(L_ManualJoinInstructionsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteReason_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))


        CASE E_SESSION_UNAVAILABLE
        
            SELECT CASE Session(SESSION_RESULT)

                CASE &H8007000E
                    CONST L_SessionUnavailableResoveHostTitle_ErrorMessage    = "Impossibile risolvere l'host"
                    CONST L_SessionUnavailableResoveHostReason_ErrorMessage   = "Errore sul server Web del Servizio conferenze di Exchange. Impossibile risolvere il nome dell'host per il server di elenchi in linea."
                    CONST L_SessionUnavailableResoveHostFix1_ErrorMessage     = "Contattare l'amministratore del sistema."

                    CALL SetError(L_SessionUnavailableResoveHostTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableResoveHostReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableResoveHostFix1_ErrorMessage)

                CASE &H8000FFFF
                    CONST L_SessionUnavailableNoRightsTitle_ErrorMessage    = "Diritti insufficienti"
                    CONST L_SessionUnavailableNoRightsReason_ErrorMessage   = "Errore sul server Web del Servizio conferenze di Exchange. Diritti insufficienti per accedere al server di elenchi in linea. È possibile che le impostazioni dell'account IIS predefinito o le impostazioni di protezione del server di elenchi in linea non siano configurate correttamente."
                    CONST L_SessionUnavailableNoRightsFix1_ErrorMessage     = "Contattare l'amministratore del sistema."

                    CALL SetError(L_SessionUnavailableNoRightsTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableNoRightsReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableNoRightsFix1_ErrorMessage)

                CASE &H800704E1
                    CONST L_SessionUnavailableBadSiteTitle_ErrorMessage    = "Sito non valido"
                    CONST L_SessionUnavailableBadSiteReason_ErrorMessage   = "Errore sul server Web del Servizio conferenze di Exchange. Impossibile trovare un'area per un sito."
                    CONST L_SessionUnavailableBadSiteFix1_ErrorMessage     = "Contattare l'amministratore del sistema."

                    CALL SetError(L_SessionUnavailableBadSiteTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableBadSiteReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableBadSiteFix1_ErrorMessage)
            
                CASE ELSE
                    CONST L_SessionUnavailableTitle_ErrorMessage    = "Server non disponibile"
                    CONST L_SessionUnavailableReason_ErrorMessage   = "Server Web del Servizio conferenze di Exchange non disponibile."
                    CONST L_SessionUnavailableFix1_ErrorMessage     = "Chiudere il browser in uso e ripetere l'operazione."
                    CONST L_SessionUnavailableFix2_ErrorMessage     = "Contattare l'amministratore del sistema."

                    CALL SetError(L_SessionUnavailableTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableFix1_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableFix2_ErrorMessage)
        
            END SELECT
        
        CASE E_SERVER_CREATE_OBJECT
            CONST L_ServerCreateObjectTitle_ErrorMessage  = "Errore di configurazione del server Web"
            CONST L_ServerCreateObjectReason_ErrorMessage = "Il server Web a cui si è tentato di connettersi non è configurato per operare con i componenti del Servizio conferenze di Exchange."
            CONST L_ServerCreateObjectFix1_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_ServerCreateObjectTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ServerCreateObjectReason_ErrorMessage)
            CALL AddFix(L_ServerCreateObjectFix1_ErrorMessage)

        CASE E_UNSUPPORTED_JAVASCRIPT_BROWSER
            CONST L_JavaScriptRequiredTitle_ErrorMessage  = "Supporto di Javascript necessario"
            CONST L_JavaScriptRequiredReason_ErrorMessage = "Per visualizzare questa pagina, è necessario utilizzare un browser che supporti Javascript, come Internet Explorer 5.0."
            CONST L_JavaScriptRequiredFix1_ErrorMessage   = "<A HREF=""http://www.microsoft.com/ie"">Get Internet Explorer</A>."
        
            CALL SetError(L_JavaScriptRequiredTitle_ErrorMessage, 0, "Browser", "Browser doesn't support javascript")
            CALL SetReason(L_JavaScriptRequiredReason_ErrorMessage)
            CALL AddFix(L_JavaScriptRequiredFix1_ErrorMessage)

        CASE E_UNSUPPORTED_TABLES_BROWSER
            CONST L_TablesRequiredTitle_ErrorMessage  = "Supporto tabelle necessario"
            CONST L_TablesRequiredReason_ErrorMessage = "Per visualizzare questa pagina, è necessario utilizzare un browser che supporti le tabelle, come Internet Explorer 5.0."
            CONST L_TablesRequiredFix1_ErrorMessage   = "<A HREF=""http://www.microsoft.com/ie"">Get Internet Explorer</A>."
        
            CALL SetError(L_TablesRequiredTitle_ErrorMessage, 0, "Browser", "Browser doesn't support tables")
            CALL SetReason(L_TablesRequiredReason_ErrorMessage)
            CALL AddFix(L_TablesRequiredFix1_ErrorMessage)

        CASE E_ACCESS_DENIED
            CONST L_AccessDeniedTitle_ErrorMessage  = "Accesso negato"
            CONST L_AccessDeniedReason_ErrorMessage = "La richiesta è stata rifiutata per mancanza di autorizzazioni."
            CONST L_AccessDeniedFix1_ErrorMessage   = "Se la conferenza richiede una password, assicurarsi che la password immessa sia corretta."
            CONST L_AccessDeniedFix2_ErrorMessage   = "Assicurarsi che la conferenza a cui si sta tentando di partecipare non sia una conferenza privata a cui non si è stati invitati."
            CONST L_AccessDeniedFix3_ErrorMessage   = "Contattare l'amministratore del sistema."

            Err.Number = E_ACCESS_DENIED_HRESULT 'Set for better display
            CALL SetError(L_AccessDeniedTitle_ErrorMessage, Value, Source, Description)
            Err.Number = E_ACCESS_DENIED 'Reset for no complications
            CALL SetReason(L_AccessDeniedReason_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix1_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix2_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix3_ErrorMessage)

        CASE E_CMS_RESTARTED
            CONST L_CMSRestartedTitle_ErrorMessage  = "Errore durante la connessione al Servizio conferenze di Exchange."
            CONST L_CMSRestartedReason_ErrorMessage = "Servizio conferenze di Exchange attualmente non disponibile."
            CONST L_CMSRestartedFix1_ErrorMessage   = "Chiudere il browser in uso e aprire una nuova connessione al Servizio conferenze di Exchange."
            CONST L_CMSRestartedFix2_ErrorMessage   = "Se non è ancora possibile connettersi, contattare l'amministratore. È possibile che il servizio non sia in esecuzione."
            
            CALL SetError(L_CMSRestartedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_CMSRestartedReason_ErrorMessage)
            CALL AddFix(L_CMSRestartedFix1_ErrorMessage)
            CALL AddFix(L_CMSRestartedFix2_ErrorMessage)
        
        CASE E_MCU_HANG
            CONST L_MCUHangTitle_ErrorMessage  = "Errore durante la connessione al server delle conferenze dati."
            CONST L_MCUHangReason_ErrorMessage = "Errore del Servizio conferenze di Exchange durante l'utilizzo del server delle conferenze dati."
            CONST L_MCUHangFix1_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_MCUHangTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_MCUHangReason_ErrorMessage)
            CALL AddFix(L_MCUHangFix1_ErrorMessage)

        CASE E_NO_GLOBAL_CONF_CALENDAR
            CONST L_NoGlobalConfCalTitle_ErrorMessage  = "Servizio conferenze di Exchange non configurato correttamente."
            CONST L_NoGlobalConfCalReason_ErrorMessage = "È possibile che per il Servizio conferenze di Exchange non sia specificata una cassetta postale per conferenze predefinita."
            CONST L_NoGlobalConfCalFix1_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_NoGlobalConfCalTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoGlobalConfCalReason_ErrorMessage)
            CALL AddFix(L_NoGlobalConfCalFix1_ErrorMessage)

        CASE E_DSGETSITENAME_NO_SITE
            CONST L_DsGetSiteNameTitle_ErrorMessage  = "Sito non individuato"
            CONST L_DsGetSiteNameReason_ErrorMessage = "Il Servizio conferenze di Exchange non riesce a individuare il relativo server di Microsoft Active Directory."
            CONST L_DsGetSiteNameFix1_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_DsGetSiteNameTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DsGetSiteNameReason_ErrorMessage)
            CALL AddFix(L_DsGetSiteNameFix1_ErrorMessage)

        CASE ELSE 'OTHER ERRORS
                    
            CONST L_DefaultTitle_ErrorMessage  = "Errore del server."
            CONST L_DefaultReason_ErrorMessage = "Il Servizio conferenze di Exchange ha rilevato un errore del server."
            CONST L_DefaultFix1_ErrorMessage   = "Contattare l'amministratore del sistema."
            
            CALL SetError(L_DefaultTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DefaultReason_ErrorMessage)
            CALL AddFix(L_DefaultFix1_ErrorMessage)

    END SELECT

    CheckSetError = Value
END FUNCTION

'== SUB: Verifies ConfLocator points to the Conference Locator
SUB Verify_ConfLocator()
    ON ERROR RESUME NEXT

	DIM AuthUser
    
	AuthUser	=  Request.ServerVariables("AUTH_USER")
    IF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) OR 0 <> Session(SESSION_ERRNUMBER) OR NOT IsObject(Session(SESSION_CONFLOCATOR)) OR NOT IsObject(Session(SESSION_CMSZONE)) OR (AuthUser <> "" AND LCase(AuthUser) <> LCase(Session(SESSION_ATTENDEE)))) THEN
        CALL SetupSessionVariables(AuthUser)
    END IF
    
    IF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) AND 0 <> Session(SESSION_ERRNUMBER)) THEN
        Err.Number      = Session(SESSION_ERRNUMBER)
        Err.Description = Session(SESSION_ERRDESCRIPTION)
        Err.Source      = Session(SESSION_ERRSOURCE)
    ELSEIF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) OR NOT IsObject(Session(SESSION_CONFLOCATOR)) OR NOT IsObject(Session(SESSION_CMSZONE))) THEN
        Result          = E_SESSION_UNAVAILABLE
    END IF
END SUB

'== SUB: Sets error if the Client browser lacks Tables and JavaScript support
SUB Check_Browser_Capabilities()
    DIM Browscap
    
    SET Browscap = Server.CreateObject("MSWC.BrowserType")

    ' No longer trying to detect javascript from the browser (wasn't working with Navigator)
    'IF (0 = Browscap.JavaScript) THEN
    '    displayState = DISPLAY_ERR_VALUE
    '    Err.Number   = E_UNSUPPORTED_JAVASCRIPT_BROWSER
    'ELSE
    IF (0 = Browscap.tables) THEN
        displayState = DISPLAY_ERR_VALUE
        Err.Number   = E_UNSUPPORTED_TABLES_BROWSER
    END IF
END SUB

'== SUB: Sets an error due to an invalid password
SUB Invalid_Password()
    CONST L_IncorrectPasswordTitle_ErrorMessage  = "Password non corretta."
    CONST L_IncorrectPasswordReason_ErrorMessage = "Non è stata immessa la password richiesta per partecipare alla conferenza. Se l'indirizzo URL è stato digitato, controllare che non vi siano errori di digitazione nella password."
    CONST L_IncorrectPasswordFix1_ErrorMessage   = "Controllare i dati immessi."
    CONST L_IncorrectPasswordFix2_ErrorMessage   = "Contattare l'organizzatore della conferenza o l'amministratore del sistema."
        
    CALL SetError(L_IncorrectPasswordTitle_ErrorMessage, 0, "Security", "Invalid Password")
    CALL SetReason(L_IncorrectPasswordReason_ErrorMessage)
    CALL AddFix(L_IncorrectPasswordFix1_ErrorMessage)
    CALL AddFix(L_IncorrectPasswordFix2_ErrorMessage)
END SUB

'== SUB: Sets error if the Conference ID is not set
SUB IsConfID()
    IF ("" = inConfID OR CONF_ID_CODED_LENGTH < Len(inConfID)) THEN
        displayState = DISPLAY_ERR_CONFID
    END IF
END SUB

'== SUB: Sets error if the DCS Meeting ID is not valid
SUB ValidateMeetingID()
    IF (CONF_ID_DECODED_LENGTH <> Len(inMeetingID)) THEN
        CONST L_NoConferenceIDTitle_ErrorMessage  = "URL di accesso alla conferenza non valido"
        CONST L_NoConferenceIDReason_ErrorMessage = "È possibile partecipare a una conferenza soltanto utilizzando un URL di accesso valido per la conferenza specificata."
        CONST L_NoConferenceIDFix1_ErrorMessage   = "Se l'URL è stato copiato, verificare i dati immessi oppure partecipare a una conferenza a cui si è stati invitati tramite posta elettronica."

        Err.Number      = Len(inMeetingID)
        Err.Description = "Invalid conference ID"
        Err.Source      = "Exchange Conferencing Service"
        CALL SetError(L_NoConferenceIDTitle_ErrorMessage, 0, "Validate Meeting ID", "Invalid Conference ID")
        CALL SetReason(L_NoConferenceIDReason_ErrorMessage)
        CALL AddFix(L_NoConferenceIDFix1_ErrorMessage)
        CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
    END IF
END SUB

'== SUB: Setup the error page when we have an error
SUB DisplayErrorPage() %>
<TITLE><%=L_ErrorPage_HTMLTitle%></TITLE>
</HEAD>
<body BGCOLOR="#FFFFFF" BACKGROUND="filespw.gif" LEFTMARGIN="40" RIGHTMARGIN="40" TEXT="#000000" LINK="#000000" ALINK="#FFCC66" VLINK="#0080FF" STYLE="background-color:#FFFFFF; background-image:url(filespw.gif); background-attachment:fixed; background-repeat:no-repeat; background-position:bottom right;">

<center>
<table CELLSPACING="12">
<tr><td COLSPAN="2" ROWSPAN="1" ALIGN="LEFT"><b><font FACE="verdana" SIZE="+3"><%=ErrorMsg%></font></b></td></tr>
<tr><td COLSPAN="2" ROWSPAN="1" ALIGN="LEFT"><font FACE="verdana" SIZE="-1">
    <%=Reason%>
    <P><%=L_TryTheFollowing_Text%></P>
    <UL>
        <%
            DIM count
            FOR count = 1 TO UBound(Fixes)
                Response.write("<LI>" + Fixes(count) + "</LI>")
            NEXT
        %>
    </UL>
    <P>
    <SMALL>
        <%=HiddenError%>
        <BR>
        <%=L_Page_HTMLTitle%>
    </SMALL>
</font></td></tr>
</table>
</center>
</body>
</HTML>
<% END SUB %>
